\chapter{Algebraic essentials}

\setlength{\epigraphwidth}{0.8\textwidth}

\epigraph{It is almost impossible for me to read contemporary mathematicians
  who, instead of saying “Petya washed his hands,” write simply: “There is a $t_1
  < 0$ such that the image of $t_1$ under the natural mapping $t_1 \mapsto
  \mathit{Petya}\!\left( t_1 \right)$ belongs to the set of dirty hands, and a
  $t_2, t_1 < t_2 \le 0$, such that the image of $t_2$ under the above-mentioned
  mapping belongs to the complement of the set defined in the preceding
  sentence.” }{Vladimir Igorevich Arnol’d \cite[p. 30]{arnold}}

\noindent
The goal of this chapter is to provide an introduction into the theory of
Gröbner bases for ideals in polynomial rings. This theory was introduced by
Bruno Buchberger \cite{bb}, who named the concept in honor of his advisor
Wolfgang Gröbner (1899--1980). Buchberger also developed the fundamental
algorithm for the computation of a Gröbner basis known as Buchberger's
algorithm. A similar concept for ideals in power series rings was introduced by
Heisuke Hironaka \cite{hh1}, \cite{hh2}.

Gröbner bases are nowadays discussed in multiple books including \cite{gb} and
\cite{iva}. We will follow these books along the way as we gradually unveil the
elegance and power of Gröbner bases in solving systems of polynomial equations.
Further information can be also found in \cite{igb} and \cite{gbs}.

As we progress, we will also define necessary algebraic structures and objects
that will allow us to model AES as a system of multivariate polynomial
equations involving only the variables of the initial key.

\input{chapters/algebra/structures}

\input{chapters/algebra/orders}

\input{chapters/algebra/division}

\input{chapters/algebra/groebner_bases}

\input{chapters/algebra/algorithms}